package com.example.listviewclicktest;

import java.util.HashMap;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.AbsListView;
import android.widget.AbsListView.OnScrollListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ImageView;
import android.widget.ListView;

public class MainActivity extends Activity implements OnItemClickListener{
	
	private ListView listview;
	public static int BIAOZHI = 1;
	public static int NONBIAOZHI = 0;
	private MyAdapter adapter;
	private String []arr = {"aaa","bbb","ccc","ddd","eee","fff","ggg","hhh","iii","jjj","hhh","kkk","zzz","yyy","www","mmm","kkk","ppp","uuu","rrr"};
	/**用于單一選擇顯示控制變量**/
	private int pre;
	HashMap<Integer,ImageView> hasmap = new HashMap<Integer,ImageView>();
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		init();
		setAdapter();
	}

	private void init(){
		listview = (ListView) findViewById(R.id.listview);
		listview.setOnItemClickListener(this);
	}
	
	private void setAdapter(){
		adapter = new MyAdapter(this,arr);
		listview.setAdapter(adapter);
	}

	@Override
	public void onItemClick(AdapterView<?> adapterView, View view, int pos, long arg3) {
		
		/**
		 * 在ListView中，使用getChildAt(index)的取值，只能是当前可见区域（列表可滚动）的子项！
		1、所以如果想获取前部的将会出现返回Null值问题；
		2、getChildCount跟getCount获取的值将会不一样（数量多时）；
		3、如果使用了getChildAt(index).findViewById(...)设置值的话，滚动列表时值就会改变了。
   			需要使用getFirstVisiblePosition()获得第一个可见的位置，在用当前的position-getFirstVisiblePosition(),再用getChildAt取值！
		 * */
		int now_pos = pos - adapterView.getFirstVisiblePosition();
		View v = adapterView.getChildAt(now_pos);
		ImageView imageView = (ImageView) v.findViewById(R.id.image);
		
		if (imageView.getVisibility() == View.VISIBLE) {
			imageView.setVisibility(View.GONE);
			adapter.setState(pos,NONBIAOZHI);
		}else{
			imageView.setVisibility(View.VISIBLE);
			adapter.setState(pos,BIAOZHI);
			// getView調用，不過非常耗費性能
//			adapter.notifyDataSetChanged();
			// 不使用notifyDataSetChanged，getView不會刷新，提高效率
			refreshListView(pos, imageView);
		}
	}

	public void refreshListView(int pos, ImageView imageView) {
		if(pre != pos && !hasmap.isEmpty()){
			ImageView image = (ImageView) hasmap.get(pre);
			image.setVisibility(View.GONE);
			hasmap.remove(pre);
		}
		pre = pos;
		hasmap.put(pre, imageView);
	}

}
